<?php
/**
 * Clase Base DP para BaseCrEventoLogDP
 *
 * @package    
 * @subpackage BaseCrEventoLogDP
 * @author     Willy
 * @version    SVN:: BaseCrEventoLogDP.class.php,v 1.1 2023-02-23 11:14:33 william.taype Exp $
 */
abstract class BaseCrEventoLogDP extends CrEventoLogBN
{
  /* N�mero de registros afectados */
  private $nRowsAffected;

  public function __construct($bSetDefault = true)
  {
    if( $bSetDefault instanceof CrEventoLogBN )
    {
      $o_CrEventoLogBN = $bSetDefault;
      if($o_CrEventoLogBN->getIdEventoLog()) : $this->setIdEventoLog($o_CrEventoLogBN->getIdEventoLog()); endif;
      if($o_CrEventoLogBN->getIdEventoTipo()) : $this->setIdEventoTipo($o_CrEventoLogBN->getIdEventoTipo()); endif;
      if($o_CrEventoLogBN->getFecha()) : $this->setFecha($o_CrEventoLogBN->getFecha()); endif;
      if($o_CrEventoLogBN->getDescripcion()) : $this->setDescripcion($o_CrEventoLogBN->getDescripcion()); endif;
      if($o_CrEventoLogBN->getDescripcionEventoTipo()) : $this->setDescripcionEventoTipo($o_CrEventoLogBN->getDescripcionEventoTipo()); endif;
      if($o_CrEventoLogBN->getClavePrimaria()) : $this->setClavePrimaria($o_CrEventoLogBN->getClavePrimaria()); endif;
      if($o_CrEventoLogBN->getValorClavePrimaria()) : $this->setValorClavePrimaria($o_CrEventoLogBN->getValorClavePrimaria()); endif;
      if($o_CrEventoLogBN->getValorAnterior()) : $this->setValorAnterior($o_CrEventoLogBN->getValorAnterior()); endif;
      if($o_CrEventoLogBN->getValorActual()) : $this->setValorActual($o_CrEventoLogBN->getValorActual()); endif;
      if($o_CrEventoLogBN->getUsuarioCreacion()) : $this->setUsuarioCreacion($o_CrEventoLogBN->getUsuarioCreacion()); endif;
      if($o_CrEventoLogBN->getFechaCreacion()) : $this->setFechaCreacion($o_CrEventoLogBN->getFechaCreacion()); endif;
    }
  }

  /* Obtiene el n�mero de registros afectados */
  public function getRowsAffected()
  {
    return $this->nRowsAffected;
  }

  public function save()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT IF(MAX(IdEventoLog),(MAX(IdEventoLog)+1), 1) AS Maximo FROM cr_evento_log;";
      $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
      $result = mysql_query($sql, $oLink);
      $row = mysql_fetch_array($result);
      $this->setIdEventoLog($row[0]);

      if($this->getIdEventoLog()){
        $a_Fields = array();

        if($this->getIdEventoLog()) : $a_Fields['IdEventoLog'] = ($this->getIdEventoLog()); endif;
        if($this->getIdEventoTipo()) : $a_Fields['IdEventoTipo'] = ($this->getIdEventoTipo()); endif;
        if($this->getFecha()) : $a_Fields['Fecha'] = ($this->getFecha()); endif;
        if($this->getDescripcion()) : $a_Fields['Descripcion'] = ($this->getDescripcion()); endif;
        if($this->getDescripcionEventoTipo()) : $a_Fields['DescripcionEventoTipo'] = ($this->getDescripcionEventoTipo()); endif;
        if($this->getNombreClavePrimaria()) : $a_Fields['NombreClavePrimaria'] = ($this->getNombreClavePrimaria()); endif;
        if($this->getValorClavePrimaria()) : $a_Fields['ValorClavePrimaria'] = ($this->getValorClavePrimaria()); endif;
        if($this->getValorAnterior()) : $a_Fields['ValorAnterior'] = ($this->getValorAnterior()); endif;
        if($this->getValorActual()) : $a_Fields['ValorActual'] = ($this->getValorActual()); endif;
        if($this->getUsuarioCreacion()) : $a_Fields['UsuarioCreacion'] = ($this->getUsuarioCreacion()); endif;
        if($this->getFechaCreacion()) : $a_Fields['FechaCreacion'] = ($this->getFechaCreacion()); endif;

        $sStringField = arrayClass::implode_keys(',', $a_Fields);
        $sStringValue = "'".implode("','", $a_Fields)."'";

        $sql = "INSERT INTO cr_evento_log (".$sStringField.") VALUES (".$sStringValue.");";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  public function update()
  {
    try
    {
      if($this->getIdEventoLog())
      {
        $a_Fields = array();

        if($this->getIdEventoLog()) : $a_Fields['IdEventoLog'] = ($this->getIdEventoLog()); endif;
        if($this->getIdEventoTipo()) : $a_Fields['IdEventoTipo'] = ($this->getIdEventoTipo()); endif;
        if($this->getFecha()) : $a_Fields['Fecha'] = ($this->getFecha()); endif;
        if($this->getDescripcion()) : $a_Fields['Fecha'] = ($this->getDescripcion()); endif;
        if($this->getDescripcionEventoTipo()) : $a_Fields['DescripcionEventoTipo'] = ($this->getDescripcionEventoTipo()); endif;
        if($this->getClavePrimaria()) : $a_Fields['NombreClavePrimaria'] = ($this->getClavePrimaria()); endif;
        if($this->getValorClavePrimaria()) : $a_Fields['ValorClavePrimaria'] = ($this->getValorClavePrimaria()); endif;
        if($this->getValorAnterior()) : $a_Fields['ValorAnterior'] = ($this->getValorAnterior()); endif;
        if($this->getValorActual()) : $a_Fields['ValorActual'] = ($this->getValorActual()); endif;
        if($this->getUsuarioCreacion()) : $a_Fields['UsuarioCreacion'] = ($this->getUsuarioCreacion()); endif;
        if($this->getFechaCreacion()) : $a_Fields['FechaCreacion'] = ($this->getFechaCreacion()); endif;

        $sStringField = arrayClass::implode_key_value(',', $a_Fields);

        $con = Conexion::getConexion();
        $sql = "UPDATE cr_evento_log SET ".$sStringField." WHERE 1 AND IdEventoLog='".$this->getIdEventoLog()."';";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  public function delete()
  {
    try
    {
      if($this->getIdEventoLog())
      {
        $a_Fields = array();

        $con = Conexion::getConexion();
        $sql = "DELETE FROM cr_evento_log WHERE 1 AND IdEventoLog='".$this->getIdEventoLog()."';"; 
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  /* B�squeda del registro por la llave primaria */
  public static function selectByPK($vIdEventoLog)
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT IdEventoLog, IdEventoTipo, Fecha, Fecha, DescripcionEventoTipo, NombreClavePrimaria, ValorClavePrimaria, ValorAnterior, ValorActual, UsuarioCreacion, FechaCreacion FROM cr_evento_log WHERE 1 AND IdEventoLog='".$vIdEventoLog."'; ";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      
      return $o_Propel?self::insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con m�todos de acceso */
  private function insertObjectBN($o_propel){
    $o_CrEventoLogDP = new CrEventoLogDP();
    $o_CrEventoLogDP->setIdEventoLog($o_propel->IdEventoLog);
    $o_CrEventoLogDP->setIdEventoTipo($o_propel->IdEventoTipo);
    $o_CrEventoLogDP->setFecha($o_propel->Fecha);
    $o_CrEventoLogDP->setDescripcion($o_propel->Fecha);
    $o_CrEventoLogDP->setDescripcionEventoTipo($o_propel->DescripcionEventoTipo);
    $o_CrEventoLogDP->setClavePrimaria($o_propel->NombreClavePrimaria);
    $o_CrEventoLogDP->setValorClavePrimaria($o_propel->ValorClavePrimaria);
    $o_CrEventoLogDP->setValorAnterior($o_propel->ValorAnterior);
    $o_CrEventoLogDP->setValorActual($o_propel->ValorActual);
    $o_CrEventoLogDP->setUsuarioCreacion($o_propel->UsuarioCreacion);
    $o_CrEventoLogDP->setFechaCreacion($o_propel->FechaCreacion);
    return $o_CrEventoLogDP;
  }
}